/*
 * Copyright 2011-14 Fraunhofer ISE
 *
 * This file is part of OpenMUC.
 * For more information visit http://www.openmuc.org
 *
 * OpenMUC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * OpenMUC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OpenMUC.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package org.openmuc.framework.authentication;

import java.util.Set;

/**
 * 
 * Service interface to get access to the framework wide user management and authentication
 * 
 */
public interface AuthenticationService {

	public abstract boolean login(String name, String password);

	public abstract boolean contains(String user);

	public abstract void delete(String user);

	public abstract void register(String user, String pwd);

	public abstract Set<String> getAllUsers();
}
