/**
 * This class file was automatically generated by jASN1 (http://www.openmuc.org)
 */

package org.openmuc.jdlms.internal.asn1.cosem;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jdlms.internal.asn1.axdr.AxdrByteArrayOutputStream;
import org.openmuc.jdlms.internal.asn1.axdr.AxdrType;
import org.openmuc.jdlms.internal.asn1.axdr.types.AxdrEnum;

public class ACTION_Request implements AxdrType {

	public byte[] code = null;

	public static enum Choices {
		_ERR_NONE_SELECTED(-1), ACTION_REQUEST_NORMAL(1), ACTION_REQUEST_NEXT_PBLOCK(2), ACTION_REQUEST_WITH_LIST(3), ACTION_REQUEST_WITH_FIRST_PBLOCK(
				4), ACTION_REQUEST_WITH_LIST_AND_FIRST_PBLOCK(5), ACTION_REQUEST_WITH_PBLOCK(6), ;

		private int value;

		private Choices(int value) {
			this.value = value;
		}

		public int getValue() {
			return value;
		}

		public static Choices valueOf(long tagValue) {
			Choices[] values = Choices.values();

			for (Choices c : values) {
				if (c.value == tagValue) {
					return c;
				}
			}
			return _ERR_NONE_SELECTED;
		}
	}

	private Choices choice;

	public Action_Request_Normal action_request_normal = null;

	public Action_Request_Next_Pblock action_request_next_pblock = null;

	public Action_Request_With_List action_request_with_list = null;

	public Action_Request_With_First_Pblock action_request_with_first_pblock = null;

	public Action_Request_With_List_And_First_Pblock action_request_with_list_and_first_pblock = null;

	public Action_Request_With_Pblock action_request_with_pblock = null;

	public ACTION_Request() {
	}

	public ACTION_Request(byte[] code) {
		this.code = code;
	}

	@Override
	public int encode(AxdrByteArrayOutputStream axdrOStream) throws IOException {
		if (code != null) {
			for (int i = code.length - 1; i >= 0; i--) {
				axdrOStream.write(code[i]);
			}
			return code.length;

		}
		if (choice == Choices._ERR_NONE_SELECTED) {
			throw new IOException("Error encoding AxdrChoice: No item in choice was selected.");
		}

		int codeLength = 0;

		if (choice == Choices.ACTION_REQUEST_WITH_PBLOCK) {
			codeLength += action_request_with_pblock.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(6);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_WITH_LIST_AND_FIRST_PBLOCK) {
			codeLength += action_request_with_list_and_first_pblock.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(5);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_WITH_FIRST_PBLOCK) {
			codeLength += action_request_with_first_pblock.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(4);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_WITH_LIST) {
			codeLength += action_request_with_list.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(3);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_NEXT_PBLOCK) {
			codeLength += action_request_next_pblock.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(2);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_NORMAL) {
			codeLength += action_request_normal.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(1);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		// This block should be unreachable
		throw new IOException("Error encoding AxdrChoice: No item in choice was encoded.");
	}

	@Override
	public int decode(InputStream iStream) throws IOException {
		int codeLength = 0;
		AxdrEnum choosen = new AxdrEnum();

		codeLength += choosen.decode(iStream);
		resetChoices();
		choice = Choices.valueOf(choosen.getValue());

		if (choice == Choices.ACTION_REQUEST_NORMAL) {
			action_request_normal = new Action_Request_Normal();
			codeLength += action_request_normal.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_NEXT_PBLOCK) {
			action_request_next_pblock = new Action_Request_Next_Pblock();
			codeLength += action_request_next_pblock.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_WITH_LIST) {
			action_request_with_list = new Action_Request_With_List();
			codeLength += action_request_with_list.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_WITH_FIRST_PBLOCK) {
			action_request_with_first_pblock = new Action_Request_With_First_Pblock();
			codeLength += action_request_with_first_pblock.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_WITH_LIST_AND_FIRST_PBLOCK) {
			action_request_with_list_and_first_pblock = new Action_Request_With_List_And_First_Pblock();
			codeLength += action_request_with_list_and_first_pblock.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.ACTION_REQUEST_WITH_PBLOCK) {
			action_request_with_pblock = new Action_Request_With_Pblock();
			codeLength += action_request_with_pblock.decode(iStream);
			return codeLength;
		}

		throw new IOException("Error decoding AxdrChoice: Identifier matched to no item.");
	}

	public void encodeAndSave(int encodingSizeGuess) throws IOException {
		AxdrByteArrayOutputStream axdrOStream = new AxdrByteArrayOutputStream(encodingSizeGuess);
		encode(axdrOStream);
		code = axdrOStream.getArray();
	}

	public Choices getChoiceIndex() {
		return choice;
	}

	public void setaction_request_normal(Action_Request_Normal newVal) {
		resetChoices();
		choice = Choices.ACTION_REQUEST_NORMAL;
		action_request_normal = newVal;
	}

	public void setaction_request_next_pblock(Action_Request_Next_Pblock newVal) {
		resetChoices();
		choice = Choices.ACTION_REQUEST_NEXT_PBLOCK;
		action_request_next_pblock = newVal;
	}

	public void setaction_request_with_list(Action_Request_With_List newVal) {
		resetChoices();
		choice = Choices.ACTION_REQUEST_WITH_LIST;
		action_request_with_list = newVal;
	}

	public void setaction_request_with_first_pblock(Action_Request_With_First_Pblock newVal) {
		resetChoices();
		choice = Choices.ACTION_REQUEST_WITH_FIRST_PBLOCK;
		action_request_with_first_pblock = newVal;
	}

	public void setaction_request_with_list_and_first_pblock(Action_Request_With_List_And_First_Pblock newVal) {
		resetChoices();
		choice = Choices.ACTION_REQUEST_WITH_LIST_AND_FIRST_PBLOCK;
		action_request_with_list_and_first_pblock = newVal;
	}

	public void setaction_request_with_pblock(Action_Request_With_Pblock newVal) {
		resetChoices();
		choice = Choices.ACTION_REQUEST_WITH_PBLOCK;
		action_request_with_pblock = newVal;
	}

	private void resetChoices() {
		choice = Choices._ERR_NONE_SELECTED;
		action_request_normal = null;
		action_request_next_pblock = null;
		action_request_with_list = null;
		action_request_with_first_pblock = null;
		action_request_with_list_and_first_pblock = null;
		action_request_with_pblock = null;
	}

}
