/**
 * This class file was automatically generated by jASN1 (http://www.openmuc.org)
 */

package org.openmuc.jdlms.internal.asn1.cosem;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jdlms.internal.asn1.axdr.AxdrByteArrayOutputStream;
import org.openmuc.jdlms.internal.asn1.axdr.AxdrType;
import org.openmuc.jdlms.internal.asn1.axdr.types.AxdrEnum;

public class SET_Request implements AxdrType {

	public byte[] code = null;

	public static enum Choices {
		_ERR_NONE_SELECTED(-1), SET_REQUEST_NORMAL(1), SET_REQUEST_WITH_FIRST_DATABLOCK(2), SET_REQUEST_WITH_DATABLOCK(
				3), SET_REQUEST_WITH_LIST(4), SET_REQUEST_WITH_LIST_AND_FIRST_DATABLOCK(5), ;

		private int value;

		private Choices(int value) {
			this.value = value;
		}

		public int getValue() {
			return value;
		}

		public static Choices valueOf(long tagValue) {
			Choices[] values = Choices.values();

			for (Choices c : values) {
				if (c.value == tagValue) {
					return c;
				}
			}
			return _ERR_NONE_SELECTED;
		}
	}

	private Choices choice;

	public Set_Request_Normal set_request_normal = null;

	public Set_Request_With_First_Datablock set_request_with_first_datablock = null;

	public Set_Request_With_Datablock set_request_with_datablock = null;

	public Set_Request_With_List set_request_with_list = null;

	public Set_Request_With_List_And_First_Datablock set_request_with_list_and_first_datablock = null;

	public SET_Request() {
	}

	public SET_Request(byte[] code) {
		this.code = code;
	}

	@Override
	public int encode(AxdrByteArrayOutputStream axdrOStream) throws IOException {
		if (code != null) {
			for (int i = code.length - 1; i >= 0; i--) {
				axdrOStream.write(code[i]);
			}
			return code.length;

		}
		if (choice == Choices._ERR_NONE_SELECTED) {
			throw new IOException("Error encoding AxdrChoice: No item in choice was selected.");
		}

		int codeLength = 0;

		if (choice == Choices.SET_REQUEST_WITH_LIST_AND_FIRST_DATABLOCK) {
			codeLength += set_request_with_list_and_first_datablock.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(5);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST_WITH_LIST) {
			codeLength += set_request_with_list.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(4);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST_WITH_DATABLOCK) {
			codeLength += set_request_with_datablock.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(3);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST_WITH_FIRST_DATABLOCK) {
			codeLength += set_request_with_first_datablock.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(2);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST_NORMAL) {
			codeLength += set_request_normal.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(1);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		// This block should be unreachable
		throw new IOException("Error encoding AxdrChoice: No item in choice was encoded.");
	}

	@Override
	public int decode(InputStream iStream) throws IOException {
		int codeLength = 0;
		AxdrEnum choosen = new AxdrEnum();

		codeLength += choosen.decode(iStream);
		resetChoices();
		choice = Choices.valueOf(choosen.getValue());

		if (choice == Choices.SET_REQUEST_NORMAL) {
			set_request_normal = new Set_Request_Normal();
			codeLength += set_request_normal.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST_WITH_FIRST_DATABLOCK) {
			set_request_with_first_datablock = new Set_Request_With_First_Datablock();
			codeLength += set_request_with_first_datablock.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST_WITH_DATABLOCK) {
			set_request_with_datablock = new Set_Request_With_Datablock();
			codeLength += set_request_with_datablock.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST_WITH_LIST) {
			set_request_with_list = new Set_Request_With_List();
			codeLength += set_request_with_list.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.SET_REQUEST_WITH_LIST_AND_FIRST_DATABLOCK) {
			set_request_with_list_and_first_datablock = new Set_Request_With_List_And_First_Datablock();
			codeLength += set_request_with_list_and_first_datablock.decode(iStream);
			return codeLength;
		}

		throw new IOException("Error decoding AxdrChoice: Identifier matched to no item.");
	}

	public void encodeAndSave(int encodingSizeGuess) throws IOException {
		AxdrByteArrayOutputStream axdrOStream = new AxdrByteArrayOutputStream(encodingSizeGuess);
		encode(axdrOStream);
		code = axdrOStream.getArray();
	}

	public Choices getChoiceIndex() {
		return choice;
	}

	public void setset_request_normal(Set_Request_Normal newVal) {
		resetChoices();
		choice = Choices.SET_REQUEST_NORMAL;
		set_request_normal = newVal;
	}

	public void setset_request_with_first_datablock(Set_Request_With_First_Datablock newVal) {
		resetChoices();
		choice = Choices.SET_REQUEST_WITH_FIRST_DATABLOCK;
		set_request_with_first_datablock = newVal;
	}

	public void setset_request_with_datablock(Set_Request_With_Datablock newVal) {
		resetChoices();
		choice = Choices.SET_REQUEST_WITH_DATABLOCK;
		set_request_with_datablock = newVal;
	}

	public void setset_request_with_list(Set_Request_With_List newVal) {
		resetChoices();
		choice = Choices.SET_REQUEST_WITH_LIST;
		set_request_with_list = newVal;
	}

	public void setset_request_with_list_and_first_datablock(Set_Request_With_List_And_First_Datablock newVal) {
		resetChoices();
		choice = Choices.SET_REQUEST_WITH_LIST_AND_FIRST_DATABLOCK;
		set_request_with_list_and_first_datablock = newVal;
	}

	private void resetChoices() {
		choice = Choices._ERR_NONE_SELECTED;
		set_request_normal = null;
		set_request_with_first_datablock = null;
		set_request_with_datablock = null;
		set_request_with_list = null;
		set_request_with_list_and_first_datablock = null;
	}

}
