/**
 * This class file was automatically generated by jASN1 (http://www.openmuc.org)
 */

package org.openmuc.jdlms.internal.asn1.cosem;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jdlms.internal.asn1.axdr.AxdrByteArrayOutputStream;
import org.openmuc.jdlms.internal.asn1.axdr.AxdrType;
import org.openmuc.jdlms.internal.asn1.axdr.types.AxdrEnum;
import org.openmuc.jdlms.internal.asn1.axdr.types.AxdrNull;
import org.openmuc.jdlms.internal.asn1.axdr.types.AxdrSequenceOf;

public class TypeDescription implements AxdrType {

	public byte[] code = null;

	public static enum Choices {
		_ERR_NONE_SELECTED(-1), NULL_DATA(0), ARRAY(1), STRUCTURE(2), BOOL(3), BIT_STRING(4), DOUBLE_LONG(5), DOUBLE_LONG_UNSIGNED(
				6), OCTET_STRING(9), VISIBLE_STRING(10), BCD(13), INTEGER(15), LONG_INTEGER(16), UNSIGNED(17), LONG_UNSIGNED(
				18), LONG64(20), LONG64_UNSIGNED(21), ENUMERATE(22), FLOAT32(23), FLOAT64(24), DATE_TIME(25), DATE(26), TIME(
				27), DONT_CARE(255), ;

		private int value;

		private Choices(int value) {
			this.value = value;
		}

		public int getValue() {
			return value;
		}

		public static Choices valueOf(long tagValue) {
			Choices[] values = Choices.values();

			for (Choices c : values) {
				if (c.value == tagValue) {
					return c;
				}
			}
			return _ERR_NONE_SELECTED;
		}
	}

	private Choices choice;

	public static class SubSeq_array implements AxdrType {

		public byte[] code = null;
		public Unsigned16 number_of_elements = null;

		public TypeDescription type_description = null;

		public SubSeq_array() {
		}

		public SubSeq_array(byte[] code) {
			this.code = code;
		}

		public SubSeq_array(Unsigned16 number_of_elements, TypeDescription type_description) {
			this.number_of_elements = number_of_elements;
			this.type_description = type_description;
		}

		@Override
		public int encode(AxdrByteArrayOutputStream axdrOStream) throws IOException {

			int codeLength;

			if (code != null) {
				codeLength = code.length;
				for (int i = code.length - 1; i >= 0; i--) {
					axdrOStream.write(code[i]);
				}
			}
			else {
				codeLength = 0;
				codeLength += type_description.encode(axdrOStream);

				codeLength += number_of_elements.encode(axdrOStream);

			}

			return codeLength;

		}

		@Override
		public int decode(InputStream iStream) throws IOException {
			int codeLength = 0;

			number_of_elements = new Unsigned16();
			codeLength += number_of_elements.decode(iStream);

			type_description = new TypeDescription();
			codeLength += type_description.decode(iStream);

			return codeLength;
		}

		public void encodeAndSave(int encodingSizeGuess) throws IOException {
			AxdrByteArrayOutputStream axdrOStream = new AxdrByteArrayOutputStream(encodingSizeGuess);
			encode(axdrOStream);
			code = axdrOStream.getArray();
		}
	}

	public static class SubSeqOf_structure extends AxdrSequenceOf<TypeDescription> {

		@Override
		protected TypeDescription createListElement() {
			return new TypeDescription();
		}

		protected SubSeqOf_structure(int length) {
			super(length);
		}

		public SubSeqOf_structure() {
		} // Call empty base constructor

	}

	public AxdrNull null_data = null;

	public SubSeq_array array = null;

	public SubSeqOf_structure structure = null;

	public AxdrNull bool = null;

	public AxdrNull bit_string = null;

	public AxdrNull double_long = null;

	public AxdrNull double_long_unsigned = null;

	public AxdrNull octet_string = null;

	public AxdrNull visible_string = null;

	public AxdrNull bcd = null;

	public AxdrNull integer = null;

	public AxdrNull long_integer = null;

	public AxdrNull unsigned = null;

	public AxdrNull long_unsigned = null;

	public AxdrNull long64 = null;

	public AxdrNull long64_unsigned = null;

	public AxdrNull enumerate = null;

	public AxdrNull float32 = null;

	public AxdrNull float64 = null;

	public AxdrNull date_time = null;

	public AxdrNull date = null;

	public AxdrNull time = null;

	public AxdrNull dont_care = null;

	public TypeDescription() {
	}

	public TypeDescription(byte[] code) {
		this.code = code;
	}

	@Override
	public int encode(AxdrByteArrayOutputStream axdrOStream) throws IOException {
		if (code != null) {
			for (int i = code.length - 1; i >= 0; i--) {
				axdrOStream.write(code[i]);
			}
			return code.length;

		}
		if (choice == Choices._ERR_NONE_SELECTED) {
			throw new IOException("Error encoding AxdrChoice: No item in choice was selected.");
		}

		int codeLength = 0;

		if (choice == Choices.DONT_CARE) {
			codeLength += dont_care.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(255);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.TIME) {
			codeLength += time.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(27);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DATE) {
			codeLength += date.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(26);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DATE_TIME) {
			codeLength += date_time.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(25);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.FLOAT64) {
			codeLength += float64.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(24);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.FLOAT32) {
			codeLength += float32.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(23);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.ENUMERATE) {
			codeLength += enumerate.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(22);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.LONG64_UNSIGNED) {
			codeLength += long64_unsigned.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(21);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.LONG64) {
			codeLength += long64.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(20);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.LONG_UNSIGNED) {
			codeLength += long_unsigned.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(18);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.UNSIGNED) {
			codeLength += unsigned.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(17);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.LONG_INTEGER) {
			codeLength += long_integer.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(16);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.INTEGER) {
			codeLength += integer.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(15);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.BCD) {
			codeLength += bcd.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(13);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.VISIBLE_STRING) {
			codeLength += visible_string.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(10);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.OCTET_STRING) {
			codeLength += octet_string.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(9);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DOUBLE_LONG_UNSIGNED) {
			codeLength += double_long_unsigned.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(6);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.DOUBLE_LONG) {
			codeLength += double_long.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(5);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.BIT_STRING) {
			codeLength += bit_string.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(4);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.BOOL) {
			codeLength += bool.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(3);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.STRUCTURE) {
			codeLength += structure.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(2);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.ARRAY) {
			codeLength += array.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(1);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.NULL_DATA) {
			codeLength += null_data.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(0);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		// This block should be unreachable
		throw new IOException("Error encoding AxdrChoice: No item in choice was encoded.");
	}

	@Override
	public int decode(InputStream iStream) throws IOException {
		int codeLength = 0;
		AxdrEnum choosen = new AxdrEnum();

		codeLength += choosen.decode(iStream);
		resetChoices();
		choice = Choices.valueOf(choosen.getValue());

		if (choice == Choices.NULL_DATA) {
			null_data = new AxdrNull();
			codeLength += null_data.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.ARRAY) {
			array = new SubSeq_array();
			codeLength += array.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.STRUCTURE) {
			structure = new SubSeqOf_structure();
			codeLength += structure.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.BOOL) {
			bool = new AxdrNull();
			codeLength += bool.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.BIT_STRING) {
			bit_string = new AxdrNull();
			codeLength += bit_string.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DOUBLE_LONG) {
			double_long = new AxdrNull();
			codeLength += double_long.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DOUBLE_LONG_UNSIGNED) {
			double_long_unsigned = new AxdrNull();
			codeLength += double_long_unsigned.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.OCTET_STRING) {
			octet_string = new AxdrNull();
			codeLength += octet_string.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.VISIBLE_STRING) {
			visible_string = new AxdrNull();
			codeLength += visible_string.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.BCD) {
			bcd = new AxdrNull();
			codeLength += bcd.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.INTEGER) {
			integer = new AxdrNull();
			codeLength += integer.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.LONG_INTEGER) {
			long_integer = new AxdrNull();
			codeLength += long_integer.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.UNSIGNED) {
			unsigned = new AxdrNull();
			codeLength += unsigned.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.LONG_UNSIGNED) {
			long_unsigned = new AxdrNull();
			codeLength += long_unsigned.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.LONG64) {
			long64 = new AxdrNull();
			codeLength += long64.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.LONG64_UNSIGNED) {
			long64_unsigned = new AxdrNull();
			codeLength += long64_unsigned.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.ENUMERATE) {
			enumerate = new AxdrNull();
			codeLength += enumerate.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.FLOAT32) {
			float32 = new AxdrNull();
			codeLength += float32.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.FLOAT64) {
			float64 = new AxdrNull();
			codeLength += float64.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DATE_TIME) {
			date_time = new AxdrNull();
			codeLength += date_time.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DATE) {
			date = new AxdrNull();
			codeLength += date.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.TIME) {
			time = new AxdrNull();
			codeLength += time.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.DONT_CARE) {
			dont_care = new AxdrNull();
			codeLength += dont_care.decode(iStream);
			return codeLength;
		}

		throw new IOException("Error decoding AxdrChoice: Identifier matched to no item.");
	}

	public void encodeAndSave(int encodingSizeGuess) throws IOException {
		AxdrByteArrayOutputStream axdrOStream = new AxdrByteArrayOutputStream(encodingSizeGuess);
		encode(axdrOStream);
		code = axdrOStream.getArray();
	}

	public Choices getChoiceIndex() {
		return choice;
	}

	public void setnull_data(AxdrNull newVal) {
		resetChoices();
		choice = Choices.NULL_DATA;
		null_data = newVal;
	}

	public void setarray(SubSeq_array newVal) {
		resetChoices();
		choice = Choices.ARRAY;
		array = newVal;
	}

	public void setstructure(SubSeqOf_structure newVal) {
		resetChoices();
		choice = Choices.STRUCTURE;
		structure = newVal;
	}

	public void setbool(AxdrNull newVal) {
		resetChoices();
		choice = Choices.BOOL;
		bool = newVal;
	}

	public void setbit_string(AxdrNull newVal) {
		resetChoices();
		choice = Choices.BIT_STRING;
		bit_string = newVal;
	}

	public void setdouble_long(AxdrNull newVal) {
		resetChoices();
		choice = Choices.DOUBLE_LONG;
		double_long = newVal;
	}

	public void setdouble_long_unsigned(AxdrNull newVal) {
		resetChoices();
		choice = Choices.DOUBLE_LONG_UNSIGNED;
		double_long_unsigned = newVal;
	}

	public void setoctet_string(AxdrNull newVal) {
		resetChoices();
		choice = Choices.OCTET_STRING;
		octet_string = newVal;
	}

	public void setvisible_string(AxdrNull newVal) {
		resetChoices();
		choice = Choices.VISIBLE_STRING;
		visible_string = newVal;
	}

	public void setbcd(AxdrNull newVal) {
		resetChoices();
		choice = Choices.BCD;
		bcd = newVal;
	}

	public void setinteger(AxdrNull newVal) {
		resetChoices();
		choice = Choices.INTEGER;
		integer = newVal;
	}

	public void setlong_integer(AxdrNull newVal) {
		resetChoices();
		choice = Choices.LONG_INTEGER;
		long_integer = newVal;
	}

	public void setunsigned(AxdrNull newVal) {
		resetChoices();
		choice = Choices.UNSIGNED;
		unsigned = newVal;
	}

	public void setlong_unsigned(AxdrNull newVal) {
		resetChoices();
		choice = Choices.LONG_UNSIGNED;
		long_unsigned = newVal;
	}

	public void setlong64(AxdrNull newVal) {
		resetChoices();
		choice = Choices.LONG64;
		long64 = newVal;
	}

	public void setlong64_unsigned(AxdrNull newVal) {
		resetChoices();
		choice = Choices.LONG64_UNSIGNED;
		long64_unsigned = newVal;
	}

	public void setenumerate(AxdrNull newVal) {
		resetChoices();
		choice = Choices.ENUMERATE;
		enumerate = newVal;
	}

	public void setfloat32(AxdrNull newVal) {
		resetChoices();
		choice = Choices.FLOAT32;
		float32 = newVal;
	}

	public void setfloat64(AxdrNull newVal) {
		resetChoices();
		choice = Choices.FLOAT64;
		float64 = newVal;
	}

	public void setdate_time(AxdrNull newVal) {
		resetChoices();
		choice = Choices.DATE_TIME;
		date_time = newVal;
	}

	public void setdate(AxdrNull newVal) {
		resetChoices();
		choice = Choices.DATE;
		date = newVal;
	}

	public void settime(AxdrNull newVal) {
		resetChoices();
		choice = Choices.TIME;
		time = newVal;
	}

	public void setdont_care(AxdrNull newVal) {
		resetChoices();
		choice = Choices.DONT_CARE;
		dont_care = newVal;
	}

	private void resetChoices() {
		choice = Choices._ERR_NONE_SELECTED;
		null_data = null;
		array = null;
		structure = null;
		bool = null;
		bit_string = null;
		double_long = null;
		double_long_unsigned = null;
		octet_string = null;
		visible_string = null;
		bcd = null;
		integer = null;
		long_integer = null;
		unsigned = null;
		long_unsigned = null;
		long64 = null;
		long64_unsigned = null;
		enumerate = null;
		float32 = null;
		float64 = null;
		date_time = null;
		date = null;
		time = null;
		dont_care = null;
	}

}
